/*
* Copyright (c) 2005 X.Org Foundation LLC
* 
* Permission is hereby granted, free of charge, to any person obtaining a copy of
* this software and associated documentation files (the "Software"), to deal in
* the Software without restriction, including without limitation the rights to
* use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
* of the Software, and to permit persons to whom the Software is furnished to do
* so, subject to the following conditions:
* 
* The above copyright notice and this permission notice shall be included in all
* copies or substantial portions of the Software.
* 
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
* SOFTWARE.
* 
* Copyright (c) Applied Testing and Technology, Inc. 1993, 1994, 1995
* Copyright (c) 88open Consortium, Ltd. 1990, 1991, 1992, 1993
* All Rights Reserved.
* 
*/
/*
 * SYNOPSIS:
 *   void
 *   XtKeysymToKeycodeList()
 */


#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <XtTest.h>

/*error messages created here*/
char	ebuf[4096];
/*allows a test to extend how long it runs*/
int	xt_tomultiple = 1;

#include <X11/IntrinsicP.h>
#include <X11/ConstrainP.h>
#include <X11/CoreP.h>

XtAppContext app_ctext;
Widget topLevel, panedw, boxw1, boxw2;
Widget labelw, rowcolw, click_quit;


#define T_XtKeysymToKeycodeList	1
char    *TestName = "XtKeysymToKeycodeList";



int 	tet_thistest;

/*
 * Set the arguments to default values for error tests
 */
static void
seterrdef()
{
}

static void t001(){

Display *display;
KeySym keysym, keysym_good;
KeyCode *keycodes_return, code;
Cardinal keycount_return;
pid_t pid2;
pid_t	pid;

 	report_purpose(1);

	report_assertion("Assertion XtKeysymToKeycodeList-1.(A)");
	report_assertion("A call to void XtKeysymToKeycodeList(display, keysym,");
	report_assertion("keycodes_return, keycount_return) shall return all the");
	report_assertion("KeyCodes that have the KeySym keysym in their entry for the");
	report_assertion("keyboard mapping table associated with the display display");
	report_assertion("and return the number KeyCodes on the list in");
	report_assertion("keycount_return.");
	FORK(pid);
	initconfig();

	FORK(pid2);
	avs_xt_hier("Tkytoklst1", "XtKeysymToKeycodeList");
	tet_infoline("PREP: Create windows for widgets and map them");
	XtRealizeWidget(topLevel);
	tet_infoline("PREP: Get display");
	display = XtDisplay(topLevel);
	tet_infoline("PREP: Get keysym for alphabet 'a'");
	keysym = XStringToKeysym("a");
	tet_infoline("PREP: Get keycode list for keysym");
	XtKeysymToKeycodeList(display, keysym, &keycodes_return, &keycount_return);
	tet_infoline("PREP: Convert keycode to keysym");
	code = *keycodes_return;
	keysym_good = XKeycodeToKeysym(display, code, 0);
	tet_infoline("TEST: Keysym values are identical");
	check_dec(keysym, keysym_good, "keysym");
	LKROF(pid2, AVSXTTIMEOUT-2);
	tet_result(TET_PASS);

	LKROF(pid, AVSXTTIMEOUT*xt_tomultiple);
}

/* Including from file Mdefcode.tmc.3024 */
/* End of included file Mdefcode.tmc.3024 */

static void t002(){

Display *display;
KeyCode *keycodes_return;
Cardinal keycount_return;
pid_t pid2;
pid_t	pid;

 	report_purpose(2);

	report_assertion("Assertion XtKeysymToKeycodeList-2.(A)");
	report_assertion("When no KeyCodes map to the KeySym keysym a call to void");
	report_assertion("XtKeysymToKeycodeList(display, keysym, keycodes_return,");
	report_assertion("keycount_return) shall return zero in keycount_return and");
	report_assertion("set keycodes_return to NULL.");
	FORK(pid);
	initconfig();

	FORK(pid2);
	avs_xt_hier("Tkytoklst2", "XtKeysymToKeycodeList");
	tet_infoline("PREP: Create windows for widgets and map them");
	XtRealizeWidget(topLevel);
	tet_infoline("PREP: Get display");
	display = XtDisplay(topLevel);
	tet_infoline("PREP: Get keycode list for keysym");
	XtKeysymToKeycodeList(display, -1,
			&keycodes_return, &keycount_return);
	tet_infoline("TEST: Keycount_return is 0");
	check_dec(0, keycount_return, "keycount_return");
	LKROF(pid2, AVSXTTIMEOUT-2);
	tet_result(TET_PASS);

	LKROF(pid, AVSXTTIMEOUT*xt_tomultiple);
}

/* Including from file Mdefcode.tmc.3024 */
/* End of included file Mdefcode.tmc.3024 */

/* End of Test Cases */


struct tet_testlist tet_testlist[] = {
	{ t001, 1 },
	{ t002, 2 },
	{ NULL, 0 }
};

int 	ntests = sizeof(tet_testlist)/sizeof(struct tet_testlist)-1;

void	(*tet_startup)() = NULL;
void	(*tet_cleanup)() = NULL;
